clear all
T=6;                                                                        0;
omega=2*pi;
b=1;
npt=10000;
dt=T/npt;
temps=linspace(0,T,npt);
x=linspace(0,T,npt)*0;
xdot=linspace(0,T,npt)*0.;
cont=linspace(0,T,npt)*0.;
x0=1;x1=2;

x(1)=x0;
x(2)=x(1)+dt*x1;
xdot(1)=x1;
xdot(2)=x1;
cmax=2.2;xi=0.05;
cont(1)=-cmax*sign(x1);
cont(2)=-cmax*sign(x1);

for i=3:npt
    x(i)=2*x(i-1)-x(i-2)-omega^2*dt^2*x(i-1)-dt^2*cmax*sign(xdot(i-1))*exp(-xi*i*dt);
    xdot(i)=(x(i)-x(i-1))/dt;
    cont(i)=-cmax*sign(xdot(i))*exp(-xi*i*dt);
end
figure
subplot(2,2,1)
plot(temps,x,'LineWidth',2,'color','k')
title(['Evolution de x avec contrle pour T= ',num2str(T)]);
ylabel(' Solution x');
xlabel('Temps')
%=========
subplot(2,2,2)
plot(temps,xdot,'LineWidth',2,'color','k')
title(['Evolution de la drivee de la solution x T= ',num2str(T)]);
ylabel(' Drivee de la solution x');
xlabel('Temps')
%======
subplot(2,2,3)
plot(x,xdot,'LineWidth',2,'color','k')
title(['Trajectoires dans le plan des phases T= ',num2str(T)]);
ylabel(' Solution dot');
xlabel('Solution x')
%=========
subplot(2,2,4)
plot(temps,cont,'LineWidth',2,'color','k')
title(['Contrle pour T = ',num2str(T),' borne = ',num2str(cmax),' xi = ',num2str(xi)]);
ylabel(' Contrle');
xlabel('Temps')