clear all
T=20;

npt=10000;
dt=T/npt;
%========
% vecteur second membre du contrle
%==========

%xq=zeros(2,npt);
%xp=zeros(2,npt);
b=[1;0];

%============
% donnes initiales
%============
beta=0;
deribeta=0.0;
alpha=.0;
derialpha=0.01;
%======
% donnes initiales
%======
init(1,1)=beta;
init(1,2)=beta+dt*deribeta;
init(2,1)=alpha;
init(2,2)=alpha+dt*derialpha;
%========
%xp=zeros(2,npt);
%xq=zeros(2,npt);
borne=.1;% borne du contrle
GRAM=zeros(4,4);
phi=linspace(0,1,4)*0.;deltaphi=linspace(0,1,4)*0.;
%
M=1000;L=100;n=100;roe=1000;g=9.81;lambda=g*(n*pi/L)^2;Mr=M/roe;
Ig=1;d=lambda;bc=0.1;e1=-.001*(n*pi/L);
a0=10;a1=-0.0001;p1=0.001;
%=========
% construction des matrices
%==================
    v=1;
    a=g*a0+a1*v^2/2;
    e=v*e1;
    p2=v*p1;
    %=============
 Ma=[Mr,0;0,Ig];
 C=[p2,-bc;bc,0];
 Kr=[a,e;0,d];%  matrices du modle
 %Ma=[1,0;0,1];C=[0,-.1;.1,0.];Kr=[1,0;0,2];%  matrices de test
%==============
% construction de la matrice de Gram
%==============

for i=1:4
    for ik=1:4
          phi(ik)=0.;
        if(ik==i) 
            phi(ik)=1;
        end
    end
           xp=calcul(phi,npt,dt,Ma,C,Kr);
    for j=1:4
        for jk=1:4
             deltaphi(jk)=0.;
                if(jk==j)
                deltaphi(jk)=1;
                end
        end
        xq=calcul(deltaphi,npt,dt,Ma,C,Kr);
        s=0;
s=s+dt*0.5*(b(1)*xp(1,npt)+b(2)*xp(2,npt))*(b(1)*xq(1,npt)+b(2)*xq(2,npt));
s=s+dt*0.5*(b(1)*xp(1,1)+b(2)*xp(2,1))*(b(1)*xq(1,1)+b(2)*xq(2,1));
%
        for nkt=2:npt-1
    s=s+dt*(b(1)*xp(1,nkt)+b(2)*xp(2,nkt))*(b(1)*xq(1,nkt)+b(2)*xq(2,nkt));
        end
        GRAM(i,j)=s;
    end
end
%======
% verification de la matrice de Gram
%======
G=GRAM;
Avertisement=('valeurs propres de GRAM elles doivent tre strictement positives')
z=eig(GRAM)% valeurs propres de GRAM elles doivent tre strictement positives
%=====
%  construction du second membre
%=========
sec(1)=Ma(1,1)*(init(1,2)-init(1,1))/dt+Ma(1,2)*(init(2,2)-init(2,1))/dt+C(1,1)*init(1,1)+C(1,2)*init(2,1);
sec(2)=Ma(2,1)*(init(1,2)-init(1,1))/dt+Ma(2,2)*(init(2,2)-init(2,1))/dt+C(2,1)*init(1,1)+C(2,2)*init(2,1);
sec(3)=-Ma(1,1)*init(1,1)-Ma(1,2)*init(2,1);
sec(4)=-Ma(2,1)*init(1,1)-Ma(2,2)*init(2,1);
%========
% Resolution du systeme de Gram
%======
phi=GRAM\sec';
%========
%  calcul de la solution avec controle exact
%======
xp=calcul(phi,npt,dt,Ma,C,Kr);
%xp=xp*0;%
sol=calcul2(init,npt,dt,Ma,C,Kr,xp,b,borne);
%===========
%  Figure
%===========
figure
u1=linspace(0,1,npt)*0;
u2=linspace(0,1,npt)*0;
temp=linspace(0,T,npt);
for n=1:npt
    u1(n)=sol(1,n);
    u2(n)=sol(2,n);
    u3(n)=min(borne,max(-borne,-xp(1,n)*b(1)-xp(2,n)*b(2)));
end
subplot(3,1,1)
plot(temp,u1,'LineWidth',2,'color','k')
xlabel ('Temps')
ylabel('Composante beta')
title(['Evolution de beta; vitesse= ',num2str(v)])

subplot(3,1,2)
plot(temp,u2,'LineWidth',2,'color','k')
xlabel('Temps')
ylabel('Composante alpha')
title(['Evolution de alpha; vitesse= ',num2str(v)])

subplot(3,1,3)
plot(temp,u3,'LineWidth',2,'color','k')
xlabel('Temps')
ylabel('Contrle')
title(['Evolution du contrle; vitesse= ',num2str(v)])