clear all
T=2;                                                                        0;
omega=2*pi;
b=1;
npt=10000;
dt=T/npt;
temps=linspace(0,T,npt);
x=linspace(0,T,npt)*0;
p=linspace(0,T,npt)*0;
xdot=linspace(0,T,npt)*0.;
cont=linspace(0,T,npt)*0.;
x0=1;x1=2;
L=[x1;-x0];
a=1+sin(2*omega*T)/(2*omega*T);
bb=(1/(2*T*omega^2))*(1-cos(2*omega*T));
c=(1/(omega^2))*(1-sin(2*omega*T)/(2*omega*T));
G=(b^2*T/2)*[a,bb;bb,c];
Phi=G\L;
p(1)=Phi(1);
p(2)=p(1)+dt*Phi(2);
for i=3:npt
    p(i)=2*p(i-1)-p(i-2)-omega^2*dt^2*p(i-1);
    cont(i)=-b*p(i);
end
x(1)=x0;
x(2)=x(1)+dt*x1;
xdot(1)=x1;
xdot(2)=x1;
cmin=-1000;
cmax=1000;
for i=3:npt
    x(i)=2*x(i-1)-x(i-2)-omega^2*dt^2*x(i-1)-dt^2*min(cmax,max(cmin,b*p(i-1)));
    xdot(i)=(x(i)-x(i-1))/dt;
end
figure
subplot(2,2,1)
plot(temps,x,'LineWidth',2,'color','k')
title(['Evolution de x avec contrle pour T= ',num2str(T)]);
ylabel(' Solution x');
xlabel('Temps')
%=========
subplot(2,2,2)
plot(temps,xdot,'LineWidth',2,'color','k')
title(['Evolution de la drivee de la solution x T= ',num2str(T)]);
ylabel(' Drivee de la solution x');
xlabel('Temps')
%======
subplot(2,2,3)
plot(x,xdot,'LineWidth',2,'color','k')
title(['Trajectoires dans le plan des phases T= ',num2str(T)]);
ylabel(' Solution dot');
xlabel('Solution x')
%=========
subplot(2,2,4)
plot(temps,cont,'LineWidth',2,'color','k')
title(['Evolution du contrle pour T= ',num2str(T)]);
ylabel(' Contrle');
xlabel('Temps')